--Author: Thomas Baumann, Andeas Krker, Steffen Keller
--Aufgabe: Spezialisierung e
--Package Body Geo.Flaechenobjekte.Kreis
with Text_Io, Ada.Integer_Text_Io, Ada.Numerics, Adagraph;


package body Geo.Flaechenobjekte.Elipse.Kreis is

   procedure Erstelle (Was : in out TKreis; P1 : in Pixel_Koordinaten; P2 : in Pixel_Koordinaten; Farbe : in Bildschirmfarbe := 1; FFarbe : Bildschirmfarbe := 2) is
   begin
      if abs(P1.X - P2.X) /= abs(P1.Y - P2.Y) then
         raise Input_Error;
      end if;
         
      Was.Bezugspunkt := P1;
      Was.Bezugspunkt2 := P2;      
      
      Was.Radius := abs(P1.X - P2.X);
      Was.Farbe := Farbe;
      Was.Fuellfarbe := FFarbe;
      Was.Flaeche := Ada.Numerics.Pi * Float(Was.Radius * Was.Radius);
   end Erstelle;
   
   
   procedure Zeige (Was : in TKreis) is
   begin
      Text_Io.Put_Line("Ich bin ein Kreis");
      Text_Io.Put("Koordiante1: x="); Ada.Integer_Text_Io.Put(Was.Bezugspunkt.X, 0);
      Text_Io.Put(", y="); Ada.Integer_Text_Io.Put(Was.Bezugspunkt.Y, 0);
      Text_Io.New_Line;
      Text_Io.Put("Koordiante2: x="); Ada.Integer_Text_Io.Put(Was.Bezugspunkt2.X, 0);
      Text_Io.Put(", y="); Ada.Integer_Text_Io.Put(Was.Bezugspunkt2.Y, 0);
      Text_Io.New_Line;
      Text_Io.Put("Radius: "); Ada.Integer_Text_Io.Put(Was.Radius, 0);
      Text_Io.New_Line;
      Text_Io.Put("Flaeche: "); Text_Io.Put(Was.Flaeche'IMG);
      Text_Io.New_Line;
      Text_Io.Put("Farbe: "); Text_Io.Put(Was.Farbe'IMG);
      Text_Io.New_Line;
      Text_Io.Put("Fuellfarbe: "); Text_Io.Put(Was.Fuellfarbe'IMG);
      Text_Io.New_Line;
   end Zeige;
   

   procedure Zeichne (Was : in TKreis) is
      Farbe : Adagraph.Color_Type;
   begin
      case Was.Farbe is
         when 1 => Farbe := Adagraph.Blue;
         when 2 => Farbe := Adagraph.Green;
         when 3 => Farbe := Adagraph.Cyan;
         when 4 => Farbe := Adagraph.Red; 
         when 5 => Farbe := Adagraph.Magenta;
         when 6 => Farbe := Adagraph.Brown;
         when 7 => Farbe := Adagraph.Light_Gray;
         when 8 => Farbe := Adagraph.Dark_Gray;
         when 9 => Farbe := Adagraph.Light_Blue;
         when 10 => Farbe := Adagraph.Light_Green;
         when 11 => Farbe := Adagraph.Light_Cyan;
         when 12 => Farbe := Adagraph.Light_Red;
         when 13 => Farbe := Adagraph.Light_Magenta;
         when 14 => Farbe := Adagraph.Yellow;
         when 15 => Farbe := Adagraph.White;
      end case;
      Adagraph.Draw_Ellipse(Was.Bezugspunkt.X, Was.Bezugspunkt.Y, Was.Bezugspunkt2.X, Was.Bezugspunkt2.Y, Farbe, Adagraph.Fill);
   end Zeichne;
   
end Geo.Flaechenobjekte.Elipse.Kreis;