--Author: Thomas Baumann, Andeas Krker, Steffen Keller
--Aufgabe: Spezialisierung e
--Package Body Geo.Flaechenobjekte.Polygon

with Text_Io, Adagraph;

package body Geo.Flaechenobjekte.Polygon is
   
   procedure Erstelle (Was : in out TPolygon; Punkte : in Ref_Ar; Farbe : Bildschirmfarbe := 1; FFarbe : Bildschirmfarbe := 2) is
      Temp_Punkte : Ref_Ar := Punkte;
      Temp_Root : Ref_Ar := Was.Eckpunkte;
      Count : Natural := 0;
   begin
      Was.Bezugspunkt := Temp_Punkte.Element;
      Was.Eckpunkte.Element := Temp_Punkte.Element;
      Temp_Punkte := Temp_Punkte.Next;
      Count := 1;
      while Temp_Punkte /= null loop
         Was.Eckpunkte.Next := new Ar;
         Was.Eckpunkte := Was.Eckpunkte.Next;
         Was.Eckpunkte.Element := Temp_Punkte.Element;
         Temp_Punkte := Temp_Punkte.Next;
         Count := Count + 1;
      end loop;
      if Count < 3 then
         raise Input_Error;
      end if;
      Was.Eckpunkte := Temp_Root;
      Was.Farbe := Farbe;
      Was.Fuellfarbe := FFarbe;
      --Flaeche fuer Polygone wird im Moment noch ein dummy Wert zugewiesen
      Was.Flaeche := 0.0;
   end Erstelle;
   
   procedure Zeige (Was : in TPolygon) is
      Temp : Ref_Ar := Was.Eckpunkte;
   begin
      Text_Io.Put("Ich bin ein Polygon.");
      Text_Io.New_Line;
      while Temp /= null loop
         Text_Io.Put("Eckpunkt "); Text_Io.Put("x= "); Text_Io.Put(Temp.Element.X'IMG); 
         Text_Io.Put(" y= "); Text_Io.Put(Temp.Element.Y'IMG); 
         Text_Io.New_Line;
         Temp := Temp.Next;
      end loop;
      Text_Io.Put("Flaeche: "); Text_Io.Put(Was.Flaeche'IMG);
      Text_Io.New_Line;
      Text_Io.Put("Farbe: "); Text_Io.Put(Was.Farbe'IMG);
      Text_Io.New_Line;
      Text_Io.Put("Fuellfarbe: "); Text_Io.Put(Was.Fuellfarbe'IMG);
      Text_Io.New_Line;
   end Zeige;
   

   procedure Zeichne (Was : in TPolygon) is
      Temp : Ref_Ar := Was.Eckpunkte;
      Farbe : Adagraph.Color_Type;
      FFarbe : Adagraph.Color_type;
      Punkt : Pixel_Koordinaten;
   begin
      case Was.Farbe is
         when 1 => Farbe := Adagraph.Blue;
         when 2 => Farbe := Adagraph.Green;
         when 3 => Farbe := Adagraph.Cyan;
         when 4 => Farbe := Adagraph.Red; 
         when 5 => Farbe := Adagraph.Magenta;
         when 6 => Farbe := Adagraph.Brown;
         when 7 => Farbe := Adagraph.Light_Gray;
         when 8 => Farbe := Adagraph.Dark_Gray;
         when 9 => Farbe := Adagraph.Light_Blue;
         when 10 => Farbe := Adagraph.Light_Green;
         when 11 => Farbe := Adagraph.Light_Cyan;
         when 12 => Farbe := Adagraph.Light_Red;
         when 13 => Farbe := Adagraph.Light_Magenta;
         when 14 => Farbe := Adagraph.Yellow;
         when 15 => Farbe := Adagraph.White;
      end case;
      case Was.FuellFarbe is
         when 1 => FFarbe := Adagraph.Blue;
         when 2 => FFarbe := Adagraph.Green;
         when 3 => FFarbe := Adagraph.Cyan;
         when 4 => FFarbe := Adagraph.Red; 
         when 5 => FFarbe := Adagraph.Magenta;
         when 6 => FFarbe := Adagraph.Brown;
         when 7 => FFarbe := Adagraph.Light_Gray;
         when 8 => FFarbe := Adagraph.Dark_Gray;
         when 9 => FFarbe := Adagraph.Light_Blue;
         when 10 => FFarbe := Adagraph.Light_Green;
         when 11 => FFarbe := Adagraph.Light_Cyan;
         when 12 => FFarbe := Adagraph.Light_Red;
         when 13 => FFarbe := Adagraph.Light_Magenta;
         when 14 => FFarbe := Adagraph.Yellow;
         when 15 => FFarbe := Adagraph.White;
      end case;

      Adagraph.Goto_XY (Temp.Element.X, Temp.Element.Y);
      Temp := Temp.Next;
      while Temp /= null loop
         Adagraph.Draw_To(Temp.Element.X, Temp.Element.Y, Farbe);
         Temp := Temp.Next;
      end loop;
      Adagraph.Draw_to (Was.Eckpunkte.Element.X, Was.Eckpunkte.Element.Y, Farbe);
      Punkt.X := ((Was.Eckpunkte.Element.X + Was.Eckpunkte.Next.Element.X) / 2);
      Punkt.Y := ((Was.Eckpunkte.Element.Y + Was.Eckpunkte.Next.Element.Y) / 2);
      Punkt.X := ((Punkt.X + Was.Eckpunkte.Next.Next.Element.X) / 2);
      Punkt.Y := ((Punkt.Y + Was.Eckpunkte.Next.Next.Element.Y) / 2);
      Adagraph.Flood_Fill(Punkt.X, Punkt.Y, FFarbe);
   end Zeichne;    


end Geo.Flaechenobjekte.Polygon; 