--Author: Thomas Baumann, Andeas Krker, Steffen Keller
--Aufgabe: Spezialisierung e
--Package body Geo.Flaechenobjekte.Punkt
with Text_Io, Ada.Integer_Text_Io, Ada.Numerics.Elementary_Functions, Adagraph;

package body Geo.Linienobjekte.Strecke is
   procedure Erstelle (Was : in out TStrecke; Wo : in Pixel_Koordinaten; Wohin : in Pixel_Koordinaten; Farbe : in Bildschirmfarbe := 1) is
   begin
      Was.Bezugspunkt := Wo;
      Was.Bezugspunkt2 := Wohin;
      Was.Laenge := Ada.Numerics.Elementary_Functions.sqrt(Float((Was.Bezugspunkt.X - Was.Bezugspunkt2.X)*(Was.Bezugspunkt.X - Was.Bezugspunkt2.X) + (Was.Bezugspunkt.Y - Was.Bezugspunkt2.Y)*(Was.Bezugspunkt.Y - Was.Bezugspunkt2.Y)));
      Was.Farbe := Farbe;
   end Erstelle;
   


   procedure Zeige (Was : in TStrecke) is
   begin
      Text_Io.Put_Line("Ich bin eine Strecke");
      Text_Io.Put("Koordiante1: x="); Ada.Integer_Text_Io.Put(Was.Bezugspunkt.X, 0);
      Text_Io.Put(", y="); Ada.Integer_Text_Io.Put(Was.Bezugspunkt.Y, 0);
      Text_Io.New_Line;
      Text_Io.Put("Koordiante2: x="); Ada.Integer_Text_Io.Put(Was.Bezugspunkt2.X, 0);
      Text_Io.Put(", y="); Ada.Integer_Text_Io.Put(Was.Bezugspunkt2.Y, 0);
      Text_Io.New_Line;
      Text_Io.Put("Laenge: "); Text_Io.Put(Was.Laenge'IMG);
      Text_Io.New_Line;
      Text_Io.Put("Farbe: "); Ada.Integer_Text_Io.Put(Integer(Was.Farbe), 0);
      Text_Io.New_Line;
   end Zeige;
   

   procedure Zeichne (Was : TStrecke) is
      Farbe : Adagraph.Color_Type;
   begin
      case Was.Farbe is
         when 1 => Farbe := Adagraph.Blue;
         when 2 => Farbe := Adagraph.Green;
         when 3 => Farbe := Adagraph.Cyan;
         when 4 => Farbe := Adagraph.Red; 
         when 5 => Farbe := Adagraph.Magenta;
         when 6 => Farbe := Adagraph.Brown;
         when 7 => Farbe := Adagraph.Light_Gray;
         when 8 => Farbe := Adagraph.Dark_Gray;
         when 9 => Farbe := Adagraph.Light_Blue;
         when 10 => Farbe := Adagraph.Light_Green;
         when 11 => Farbe := Adagraph.Light_Cyan;
         when 12 => Farbe := Adagraph.Light_Red;
         when 13 => Farbe := Adagraph.Light_Magenta;
         when 14 => Farbe := Adagraph.Yellow;
         when 15 => Farbe := Adagraph.White;
      end case;
      Adagraph.Goto_XY(Was.Bezugspunkt.X, Was.Bezugspunkt.Y);
      Adagraph.Draw_To(Was.Bezugspunkt2.X, Was.Bezugspunkt2.Y, Farbe);
   end Zeichne;

   
end Geo.Linienobjekte.Strecke;
